#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>

#include "map.h"
#include "dict.h"

struct dict;

enum {
	NBUCKETS = 331
};

static unsigned
str_hash(const char *str)
{
	unsigned h = 0;

	while (*str)
		h = (h << 4) + *(const unsigned char *)str++;

	return h;
}

static int
str_equals(const char *p, const char *q)
{
	return strcmp(p, q) == 0;
}

struct dict *
dict_make(void)
{
	return (struct dict *)map_make(NBUCKETS,
	  (unsigned(*)(const void *))str_hash,
	  (int(*)(const void *, const void *))str_equals);
}

void
dict_put(struct dict *pt, const char *key, void *value)
{
	map_put((struct map *)pt, strdup(key), value);
}

void *
dict_get(struct dict *pt, const char *key)
{
	return map_get((struct map *)pt, key);
}

void
dict_free(struct dict *pt, void(*free_data)(void *))
{
	map_free((struct map *)pt, free, free_data);
}
