#include <GL/gl.h>
#include <GL/glu.h>

#include "matrix.h"
#include "gl_util.h"

void
mat_to_opengl(float *r, const struct matrix *m)
{
	r[0] = m->m11;  r[4] = m->m12;  r[8] = m->m13; r[12] = m->m14;
	r[1] = m->m21;  r[5] = m->m22;  r[9] = m->m23; r[13] = m->m24;
	r[2] = m->m31;  r[6] = m->m32; r[10] = m->m33; r[14] = m->m34;
	r[3] = 0.f;     r[7] = 0.f;    r[11] = 0.f;    r[15] = 1.f;
}

void
set_opengl_matrix(const struct matrix *m)
{
	static float fm[16];

	glLoadIdentity();
	mat_to_opengl(fm, m);
        glMultMatrixf(fm);
}
