#ifndef MAP_H_
#define MAP_H_

struct map;

struct map *
map_make(int nbuckets, unsigned (*key_hash)(const void *),
  int (*key_equals)(const void *, const void *));

void
map_put(struct map *map, void *key, void *value);

void *
map_get(struct map *map, const void *key);

void
map_free(struct map *map, void (*free_key)(void *), void (*free_data)(void *));

#endif /* MAP_H_ */
